function LoremIpsum(Sender) {
  var f = new TForm(WeBuilder);
  f.Width = 190;
  f.Height = 192;
  f.Position = poScreenCenter;
  f.BorderStyle = bsSingle; //disable dialog resizing
  f.BorderIcons = biSystemMenu; //remove maximize & minimize buttons
  f.Caption = "Lorem Ipsum";
  
  var mleft=14;
  var mtop=14;
  var vspace=24;
  var hspace=76;
  
  var lbParas = new TLabel(f);
  lbParas.Parent = f;
  lbParas.Caption = "Paragraphs:";
  lbParas.SetBounds(mleft, mtop, 75, 15);

  var txtParas = new TEdit(f);
  txtParas.Parent = f;
  txtParas.Text=1;
  txtParas.SetBounds(mleft+hspace, mtop-3, 40, 21);
  
  var lbLength = new TLabel(f);
  lbLength.Parent = f;
  lbLength.Caption = "Length:";
  lbLength.SetBounds(mleft, mtop+(vspace*1), 75, 15);
  
  var cmbLength = new TComboBox(f);
  cmbLength.Parent = f;
  cmbLength.Items.Add("Short");
  cmbLength.Items.Add("Medium");
  cmbLength.Items.Add("Long");
  cmbLength.Items.Add("VeryLong");
  cmbLength.ItemIndex = 1;
  cmbLength.SetBounds(mleft+hspace, mtop+(vspace*1)-3, 80, 21);
  
  hspace=81;
  
  var chkDecorate = new TCheckBox(f);
  chkDecorate.Parent = f;
  chkDecorate.Checked = true;
  chkDecorate.setBounds(mleft, mtop+(vspace*2), 15, 15);
  var lblDecorate = new TLabel(f);
  lblDecorate.Parent = f;
  lblDecorate.Caption = "Decorate";
  lblDecorate.setBounds(mleft+20, mtop+(vspace*2), 55, 15);
  
  var chkHeaders = new TCheckBox(f);
  chkHeaders.Parent = f;
  chkHeaders.Checked = false;
  chkHeaders.setBounds(mleft+hspace, mtop+(vspace*2), 15, 15); 
  var lblHeaders = new TLabel(f);
  lblHeaders.Parent = f;
  lblHeaders.Caption = "Headers";
  lblHeaders.setBounds(mleft+hspace+20, mtop+(vspace*2), 55, 15);
  
  var chkLists = new TCheckBox(f);
  chkLists.Parent = f;
  chkLists.Checked = false;
  chkLists.setBounds(mleft, mtop+(vspace*3), 15, 15);
  var lblLists = new TLabel(f);
  lblLists.Parent = f;
  lblLists.Caption = "Lists";
  lblLists.setBounds(mleft+20, mtop+(vspace*3), 55, 15);
  
  var chkLinks = new TCheckBox(f);
  chkLinks.Parent = f;
  chkLinks.Checked = false;
  chkLinks.setBounds(mleft+hspace, mtop+(vspace*3), 15, 15); 
  var lblLinks = new TLabel(f);
  lblLinks.Parent = f;
  lblLinks.Caption = "Links";
  lblLinks.setBounds(mleft+hspace+20, mtop+(vspace*3), 55, 15);
  
  var chkCaps = new TCheckBox(f);
  chkCaps.Parent = f;
  chkCaps.Checked = false;
  chkCaps.setBounds(mleft, mtop+(vspace*4), 15, 15);
  var lblCaps = new TLabel(f);
  lblCaps.Parent = f;
  lblCaps.Caption = "All Caps";
  lblCaps.setBounds(mleft+20, mtop+(vspace*4), 55, 15);
  
  var chkPrude = new TCheckBox(f);
  chkPrude.Parent = f;
  chkPrude.Checked = false;
  chkPrude.setBounds(mleft+hspace, mtop+(vspace*4), 15, 15); 
  var lblPrude = new TLabel(f);
  lblPrude.Parent = f;
  lblPrude.Caption = "Prude";
  lblPrude.setBounds(mleft+hspace+20, mtop+(vspace*4), 55, 15);
  
  var btnOk = new TButton(f);
  btnOK.Parent = f;
  btnOk.SetBounds(mleft, mtop+(vspace*5), 75, 25);
  btnOk.Caption = "OK";
  btnOk.Default = True;
  btnOK.ModalResult = mrOK;

  var btnCancel = new TButton(f);
  btnCancel.Parent = f;
  btnCancel.SetBounds(95, mtop+(vspace*5), 75, 25);
  btnCancel.Caption = "Cancel";
  btnCancel.Cancel = True;
  btnCancel.ModalResult = mrCancel;

  var r = f.ShowModal;

  if (r == mrOK) {
    var url = "http://loripsum.net/api/" + txtParas.Text + "/" + cmbLength.Text;
    if (chkDecorate.Checked) url = url + "/decorate";
    if (chkHeaders.Checked) url = url + "/headers";
    if (chkLists.Checked) url = url + "/ul/ol";
    if (chkLinks.Checked) url = url + "/link";
    if (chkCaps.Checked) url = url + "/allcaps";
    if (chkPrude.Checked) url = url + "/prude";
    Script.HTTPGet(url, &OnDownloaded);
  }

  delete f;
}

function OnDownloaded(Data) {
  Data = Trim(Data);
  if (Data != "") {
    Editor.SelText = Data;
  }
}

Script.RegisterDocumentAction("", "Lorem Ipsum", "", &LoremIpsum);